CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  SPRX = 0
  SPRY = 1
  SPRP = 2
  SPRC = 3

  Reset = 13  

  cols = 64
  rows = 48
  tiles = cols * rows
  spacetile = $8000 + $20 << 6

VAR
  long  stack[256]

  long  col, row, color
  long  array[tiles/2]
  long  colors[8 * 2]

  long  cog
  long  frame
  long  T0

  byte  sprs[8]   

  long  txtx,txty

  byte  vdipstring[256]
  byte  vdipbuf[256]
  byte  vdipstring2[256]
  long  vdipready
  long  readingfilebytes
  long  readsize
  long  getfilesize,filesize
  long  eepromptr

  long  PropGFXInserted    

OBJ
  Lite     : "GFX_BINARY_Databus"

PUB Main | i,ocnt

  repeat

    PropGFXInserted:=0
    Lite.PropGFX_Start
    if(Lite.PropGFX_TestValid<>0)
      Lite.GetID
      PropGFXInserted:=Lite.RequestIDVersion
     
    if PropGFXInserted

      do_demo
      return

PUB do_polystuff(x,y,polybase) | i
  repeat i from 0 to 2
    polydata[ 1]:=(cnt>>7&255)
    polydata[ 2]:=((cnt>>10&127)*x)>>7
    polydata[ 3]:=((cnt>>11&127)*y)>>7
    polydata[ 4]:=((cnt>>13&127)*x)>>7
    polydata[ 5]:=((cnt>> 9&127)*y)>>7
    polydata[ 6]:=((cnt>>11&127)*x)>>7          
    polydata[ 7]:=((cnt>>12&127)*y)>>7

    polydata[ 8]:=Lite#PROPGFX_POLY_PLOT
    polydata[ 9]:=(cnt>>6&255)
    polydata[10]:=((cnt>>5&127)*x)>>7
    polydata[11]:=((cnt>>17&127)*y)>>7

    polydata[12]:=Lite#PROPGFX_POLY_CIRCLE
    polydata[13]:=(cnt>>5&255)
    polydata[14]:=((cnt>>5&127)*x)>>7
    polydata[15]:=((cnt>>8&127)*y)>>7
    polydata[16]:=(cnt>>3&31)+5

    polydata[17]:=Lite#PROPGFX_POLY_LINE
    polydata[18]:=(cnt>>5&255)
    polydata[19]:=((cnt>>10&127)*x)>>7
    polydata[20]:=((cnt>>11&127)*y)>>7
    polydata[21]:=((cnt>>13&127)*x)>>7
    polydata[22]:=((cnt>> 9&127)*y)>>7

    polydata[23]:=Lite#PROPGFX_POLY_STOP
  
    Lite.SendBuf(@polydata[1],polybase,23*2 )
    Lite.DoPolys

PUB do_lots_of_polys(x,y,polybase) | i
  repeat i from 0 to 1000
    do_polystuff(x,y,polybase)

  repeat 1
    waitcnt (clkfreq + cnt)

PUB doTVText
  Lite.SetParallaxMode(32,14,Lite#PROPGFX_NTSC,4)
  setcolors(@tvtextpal)
  Lite.SendBuf(@colors,$1600,8*8)
  TVTextPrint(0,0,string("Hello Prop World"))
  repeat 3
    waitcnt (clkfreq + cnt)
  
PUB setcolors(colorptr) | i, fore, back
  repeat i from 0 to 7
    fore := byte[colorptr][i << 1]
    back := byte[colorptr][i << 1 + 1]
    colors[i << 1]     := fore << 24 + back << 16 + fore << 8 + back
    colors[i << 1 + 1] := fore << 24 + fore << 16 + back << 8 + back

pub TVTextPrint(x,y,c)
  repeat while byte[c][0]
    TVTextPrt(byte[c][0],x,y)
    x++
    c++

PUB TVTextPrt(c,x,y)
  Lite.PokeWord($1800+((y   * 32 + x)*2), (c & 1) << 10 + $200 + c & $FE )
  Lite.PokeWord($1800+((y+1 * 32 + x)*2), (c & 1) << 10 + $200 + c & $FE +1 )

PUB dostuff(ptr) | i,x,y
  Lite.SendBuf(@sprite_images,$5000,8960)
  Lite.SendBuf(@sprite_pal,$1700,$100)

  i:=2
  repeat y from 0 to 2
    repeat x from 0 to 2
      Lite.SetSprite(y*18+x*6+0,x*64+16   ,y*64   ,0,$2000+i*2)
      Lite.SetSprite(y*18+x*6+1,x*64+16+24,y*64   ,0,$2001+i*2)
      Lite.SetSprite(y*18+x*6+2,x*64+16   ,y*64+21,0,$200e+i*2)
      Lite.SetSprite(y*18+x*6+3,x*64+16+24,y*64+21,0,$200f+i*2)
      Lite.SetSprite(y*18+x*6+4,x*64+16   ,y*64+42,0,$201c+i*2)
      Lite.SetSprite(y*18+x*6+5,x*64+16+24,y*64+42,0,$201d+i*2)

  repeat i from 255 to 64
    Lite.WaitVSync
    polydata[1]:=Lite#PROPGFX_POLY_CLS
    polydata[2]:=Lite#PROPGFX_POLY_CIRCLE
    polydata[3]:=1
    polydata[4]:=i
    polydata[5]:=48
    polydata[6]:=48
    polydata[7]:=Lite#PROPGFX_POLY_CIRCLE
    polydata[8]:=2
    polydata[9]:=i
    polydata[10]:=48
    polydata[11]:=44
    polydata[12]:=Lite#PROPGFX_POLY_CIRCLE
    polydata[13]:=3
    polydata[14]:=i
    polydata[15]:=48
    polydata[16]:=40
    polydata[17]:=Lite#PROPGFX_POLY_CIRCLE
    polydata[18]:=4
    polydata[19]:=i
    polydata[20]:=48
    polydata[21]:=36
    polydata[22]:=Lite#PROPGFX_POLY_CIRCLE
    polydata[23]:=5
    polydata[24]:=i
    polydata[25]:=48
    polydata[26]:=32
    polydata[27]:=Lite#PROPGFX_POLY_STOP
    Lite.SendBuf(@polydata[1],ptr,27*2 )
    Lite.DoPolys

  repeat 2
    waitcnt (clkfreq + cnt)

  do_lots_of_polys(128,96,ptr)

PUB do_demo | i,j,ocnt,x,y
  j:=Lite#PROPGFX_FILLED_MODE

  Lite.SetSpeccyMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_SPECCY_MODE,Lite#PROPGFX_1_3D_COGS,j,1)
  repeat i from 0 to 767
    Lite.PokeByte($3800+i,i) 'set spectrum attributes
  dostuff(Lite#PROPGFX_POLY_BUFF_BASE)

'  repeat

  Lite.SetBasicMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_8BIT_BITMAP_MODE,Lite#PROPGFX_1_3D_COGS,j,1)
  Lite.R_W_EEPROM(0,$1600,$1600,$100)
  dostuff(Lite#PROPGFX_POLY_BUFF_BASE)

  Lite.SetSpeccyMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_SPECCY_MODE,Lite#PROPGFX_1_3D_COGS,j,1)
  repeat i from 0 to 767
    Lite.PokeByte($3800+i,i) 'set spectrum attributes
  dostuff(Lite#PROPGFX_POLY_BUFF_BASE)

  Lite.SetBasicMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_4BIT_BITMAP_MODE,Lite#PROPGFX_1_3D_COGS,j,1)
  dostuff(Lite#PROPGFX_POLY_BUFF_BASE)

  Lite.SetBasicMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_2BIT_BITMAP_MODE,Lite#PROPGFX_1_3D_COGS,j,1)
  dostuff(Lite#PROPGFX_POLY_BUFF_BASE)
  
  Lite.SetBasicMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_8BIT_BITMAP_MODE,Lite#PROPGFX_1_3D_COGS,j,0)
  dostuff(Lite#PROPGFX_POLY_BUFF_BASE)

  Lite.SetPolyWindow(Lite#PROPGFX_POLY_BUFF_BASE,16,16,96,64)
  do_lots_of_polys(160,200,Lite#PROPGFX_POLY_BUFF_BASE)

  Lite.Set16ColourSprites
  Lite.R_W_EEPROM(0,$1600,$1700,$100)
  Lite.R_W_EEPROM(0,$4000,Lite#PROPGFX_SPRSET_BASE,$1800)
  Lite.SetPolyWindow(Lite#PROPGFX_POLY_BUFF_BASE,16,16,96,64)

  repeat
    Lite.WaitVSync  
    dospr
    do_polystuff(160,200,Lite#PROPGFX_POLY_BUFF_BASE)
    do_polystuff(160,200,Lite#PROPGFX_POLY_BUFF_BASE)

pub dospr | dx,dy,sptr
  frame++
  sptr:=@loadme
  repeat dy from 0 to 3
    repeat dx from 0 to 9'15
      word[sptr][SPRX]:=((sin(     (frame*32+(((dx+(dy*10)))*204)))*240)>>17)+120
      word[sptr][SPRY]:=((sin($800+(frame*32+(((dx+(dy*10)))*204)))*176)>>17)+88
      word[sptr][SPRP]:=15
      word[sptr][SPRC]:=(dx<<1)+(dy&1<<6)
      sptr+=8
  Lite.SendBuf(@loadme,$13c0,40*8)

pub plot(x,y)
  Lite.GetBuf($2000+(y<<5)+(x>>3),@T0,1)
  T0|=($80>>(x&7))
  Lite.SendBuf(@T0,$2000+(y<<5)+(x>>3),1)  

pub prt(x,y,c)
  repeat while byte[c][0]
    prtchar(x,y,byte[c][0])
    x++
    c++
pub prtchar(x,y,c) | xx,yy
  repeat yy from 0 to 7
    Lite.SendBuf(@specfont[((c-32)<<3)+yy],$2000+(((y<<3)+yy)<<5)+x,1) 

pub printat(x,y)
  txtx:=x
  txty:=y
  
pub printstring(s)
  repeat while byte[s][0]
    printchar(byte[s][0])
    s++

pub printchar(c)
 T0:=c
 Lite.SendBuf(@T0,$1800+((txty<<5+txtx)<<1),2)
 txtx++
 if(txtx>31)
   txtx:=0
   txty++
   if(txty>24)
     txty:=0

pub printhex(v)
  printchar(hextab[(v>>4)&15])
  printchar(hextab[v&15])

PUB Sin(val) : retval | c,z
  c:=val
  if c&$800
    val:=$7ff-val
  retval:=word[$e000][val&$7ff]
  if c&$1000
    retval:=-retval

DAT

vgacolors     long
              long      $3C043C04       'lt grey on dk grey
              long      $3C3C0404
              long      $C000C000       'red
              long      $C0C00000
              long      $30003000       'green
              long      $30300000
              long      $0C000C00       'blue
              long      $0C0C0000
              long      $FC00FC00       'white
              long      $FCFC0000
              long      $FF80FF80       'red/white
              long      $FFFF8080
              long      $FF20FF20       'green/white
              long      $FFFF2020
              long      $FF28FF28       'cyan/white
              long      $FFFF2828
              long      $C0408080       'redbox
              long      $3010F020       'greenbox
              long      $3C142828       'cyanbox
              long      $FC54A8A8       'greybox
              long      $3C14FF28       'cyanbox+underscore
              long      $F030C050       'graphics colors

hextab        byte      "0123456789ABCDEF"

polydata      word      510
              word      1,64,0,0,48,128,96
              word      2,0,32,128,48,96,64
              word      3,64,0,512,192,64,192
              word      511,0

fffff9ff      long      $fff9ffff,$fff9ffff

checkbuf      long      0,0,0,0,0,0,0,0

specfont      file      "spectrumfont.bin"

sprite_images file      "myikspr.JCS"
sprite_pal    file      "myikspr.pal"

enterstr      byte      13,0,0,0

'                       fore   back
'                       color  color
tvtextpal     byte      $07,   $0A    '0    white / dark blue
              byte      $07,   $BB    '1    white / red
              byte      $9E,   $9B    '2   yellow / brown
              byte      $04,   $07    '3     grey / white
              byte      $3D,   $3B    '4     cyan / dark cyan
              byte      $6B,   $6E    '5    green / gray-green
              byte      $BB,   $CE    '6      red / pink
              byte      $3C,   $0A    '7     cyan / blue

loadme word 0[600*7] 'buffer